// HP 1744A
// auto-store knob

xy1=5.9;
h1=2.54;
xy2=4.44;
h2=8.24;
xyi=3.2;
di=1.5;
$fn=29;
mink=1;

knob();
//base();
//upper();

module knob() {
  base();
  upper();
}

module base() {
  difference() {
    translate([-xy1/2+mink/2,-xy1/2+mink/2,0]) minkowski() {cube([xy1-mink,xy1-mink,h1-0.001]); cylinder(d=mink, h=0.001); };
    translate([-xyi/2,-xyi/2,0]) cube([xyi,xyi,h1]);
    translate([-xyi/2,-xyi/2,0]) cylinder(d=di, h=h1);
    translate([-xyi/2,xyi/2,0]) cylinder(d=di, h=h1);
    translate([xyi/2,-xyi/2,0]) cylinder(d=di, h=h1);
    translate([xyi/2,xyi/2,0]) cylinder(d=di, h=h1);
  }
}

module upper() {
  minkowski() {
    upp2(mink);
    sphere(d=mink); 
  }
}

module upp2(mink) {
  r1=10;
  difference() {
    translate([0,0,h1]) linear_extrude(height=h2-mink/2, scale=(xy2/xy1)) translate([-xy1/2+mink/2,-xy1/2+mink/2,0]) square([xy1-mink,xy1-mink]); 
    translate([0,0,h1+h2-mink/2+r1-.35]) sphere(r=r1);
  }
}

module upper2() {
  r1=10;
  difference() {
    translate([0,0,h1]) linear_extrude(height=h2, scale=(xy2/xy1)) projection(cut = true) translate([-xy1/2+mink/2,-xy1/2+mink/2,0]) minkowski() {cube([xy1-mink,xy1-mink,0.0001]); cylinder(d=mink, h=0.001); };
    translate([0,0,h1+h2+r1-.35]) sphere(r=r1);
  }
}